unit UEditUpDown;

(*
Composant TEditUpDown
  Version 1.5

Creer le 17/05/2004
Modif le 27/12/2004

Version 1.0
  - Le mask correspond au numero dans tedit
  - Ajout d'une property Pluriel pour mettre automatiquement un s a la fin des mots
  -

Version 2.0
  - Lors de la cration faire qu'il prenne automatiquement la taille 130*21
  - Faire une limite valide pour les MAX et Min: c'est que de l'integer Attention
  - Travailler les dates

*)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls , StrUtils, StdCtrls;

const
  C_CARACMASK = '';

type
  TUpDownSimple = class(TCustomUpDown);

  TEditUpDown = class(TEdit)
  private
    FCoef, FMaskMin, FMaskMax: String;
    Fudv: TUpDownSimple;
    FUpDownEnabled, FVoirSigne, FPluriel: Boolean;

    //FOnKeyDown: TNotifyEvent;
    function CreateUpDown: TUpDownSimple;

    //procedure SelfKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure udvClick(Sender: TObject; Button: TUDBtnType);

    function CreerMask(const nMask: String): String;
    function Caractere(c: String; n: Integer): String;
    procedure txmudvChange(Key: Word);
    //function AppliquerMask(Texte, Valeur: String): String;

    function txmLire(): Integer;
    procedure txmEcrire(Valeur: Integer);

    procedure udvDeplace();
    procedure CacheUpDown(Valeur: Boolean);

    procedure WMSize(var Message: TWMSize); message WM_SIZE;
    procedure WMMove(var Message: TWMMove); message WM_Move;
    procedure WMMouseWheel(var Message: TWMMouseWheel); message WM_MouseWheel;
    procedure WMKeyDown(var Message: TWMKeyDown); message WM_KeyDown;
    procedure WMPaste(var Message: TMessage); message WM_PASTE;
    procedure WMCut(var Message: TMessage); message WM_CUT;
    procedure WMClear(var Message: TMessage); message WM_CLEAR;
    procedure WMLButtonUp(var Message: TWMLButtonUp); message WM_LBUTTONUP;
    //procedure CMEnter(var Message: TCMEnter); message CM_ENTER;
    procedure WMSetFocus(var Message: TWMSetFocus); message WM_SETFOCUS;
    procedure CMEnabledChanged(var Message: TMessage); message CM_ENABLEDCHANGED;

    procedure EcrireMax(Valeur: String);
    procedure EcrireMin(Valeur: String);
    function StrInt(S: String): Integer;
    
    function CountNombre(S: String): Integer;
    function NombreSuivantPlace(S: String; P: Integer): Integer;

    function IsNumeric(const Carac: Char): Boolean;
    function PlaceSuivantPosition(S: String; P: Integer): Integer;
    procedure SelectionNombre(P: Integer);
    function PosEx(const SubStr, S: string; Offset: Cardinal = 1): Integer;
  protected
    //procedure KeyDown(var Key: Word; Shift: TShiftState); override;
    //procedure KeyPress(Sender: TObject; var Key: Char); override;
    procedure KeyPress(var Key: Char); override;
  public
    Constructor Create(AOwner:TComponent); override;
    Destructor Destroy; override;


    function LireMask(S: String): Integer;
    function EcrireMask(S: String): String;
  published
    property Pluriel: Boolean read FPluriel write FPluriel default False;
    property UpDownEnabled: Boolean read FUpDownEnabled write CacheUpDown default True;
    property VoirSigne: Boolean read FVoirSigne write FVoirSigne default False;

    property Coeficient: string read FCoef write FCoef;
    property MaskMax: String read FMaskMax write EcrireMax;
    property MaskMin: String read FMaskMin write EcrireMin;
    property Position: Integer read txmLire write txmEcrire;
    property OnKeyDown;
    property OnKeyPress;
    property Text;
  end;

procedure Register;


implementation


//-------------------------------------------------------------------
// Tous pour les txm et udv
// Procedure globale

function TEditUpDown.PosEx(const SubStr, S: string; Offset: Cardinal = 1): Integer;
var
  I,X: Integer;
  Len, LenSubStr: Integer;
begin
  if Offset = 1 then
    Result := Pos(SubStr, S)
  else
  begin
    I := Offset;
    LenSubStr := Length(SubStr);
    Len := Length(S) - LenSubStr + 1;
    while I <= Len do
    begin
      if S[I] = SubStr[1] then
      begin
        X := 1;
        while (X < LenSubStr) and (S[I + X] = SubStr[X + 1]) do
          Inc(X);
        if (X = LenSubStr) then
        begin
          Result := I;
          exit;
        end;
      end;
      Inc(I);
    end;
    Result := 0;
  end;
end;

function TEditUpDown.CreerMask(const nMask: String): String;
var i: Integer;
begin
  result:= nMask;
  for i:= 0 to 9 do result:= StringReplace(result, inttostr(i), C_CARACMASK, [rfReplaceAll]);
end;

function TEditUpDown.Caractere(c: String; n: Integer): String;
var i: Integer;
begin
  result:= '';
  for i:= 0 to n - 1 do result:= result + c;
end;

function TEditUpDown.IsNumeric(const Carac: Char): Boolean;
begin
  result:= (ord('0') <= ord(Carac)) and (ord(Carac) <= ord('9'));
end;

function TEditUpDown.StrInt(S: String): Integer;
var E: Integer;
begin
  val(S, result, E);
end;

function TEditUpDown.NombreSuivantPlace(S: String; P: Integer): Integer;
var
  Debut: Integer;
  sMask: String;
begin
  sMask:= CreerMask(S) + C_CARACMASK;
  Debut:= 0;
  repeat
    Debut:= PosEx(C_CARACMASK, sMask, Debut + 1);
    result:= StrInt(copy(S, Debut, Length(S)));
    while sMask[Debut] = C_CARACMASK do inc(Debut);
    Dec(P);
  until (P <= 0);
  //if FVoirSigne and (S[1] = '-') then result:= -result;
end;

function TEditUpDown.PlaceSuivantPosition(S: String; P: Integer): Integer;
var
  Debut: Integer;
  sMask: String;
begin
  sMask:= CreerMask(S) + ' ' + C_CARACMASK;
  Debut:= 0;
  result:= 0;
  repeat
    Debut:= PosEx(C_CARACMASK, sMask, Debut + 1);
    if Debut > p+1 then break;
    while sMask[Debut] = C_CARACMASK do inc(Debut);
    inc(result);
  until result > 100;
  if result > 100 then result:= 0;
end;

function TEditUpDown.CountNombre(S: String): Integer;
var
  Debut: Integer;
  sMask: String;
begin
  sMask:= CreerMask(S);
  Debut:= 0;
  result:= 0;
  repeat
    Debut:= PosEx(C_CARACMASK, sMask, Debut + 1);
    if Debut = 0 then break;
    while sMask[Debut] = C_CARACMASK do inc(Debut);
    inc(result);
  until result > 100;
end;

function TEditUpDown.LireMask(S: String): Integer;
var i: Integer;
begin
  result:= 0;
  if S = '' then exit;
  for i:= 1 to CountNombre(FCoef) do
    result:= result + NombreSuivantPlace(S, i) * NombreSuivantPlace(FCoef, i);
  if FVoirSigne and (S[1] = '-') then result:= -result;
end;

function TEditUpDown.EcrireMask(S: String): String;
var
  i, j, k, d, Debut: Integer;
  t: String;
  Negatif: Boolean;
begin
  if S = '' then exit;
  //si S n'est pas un nombre alors
  i:= StrInt(S);
  if Length(IntToStr(i)) <> Length(S) then i:= LireMask(S);
  // Applique le pluriel
  if FPluriel then begin
    if Text[length(Text)] = 's' then Text:= copy(Text, 1, Length(Text) - 1);
    if LireMask(Text) > 1 then Text:= Text + 's';
  end;
  // Applique Signe
  Negatif:= i < 0;
  i:= abs(i);

  result:= CreerMask(Text);
  Debut:= 0;
  for j:= 1 to CountNombre(Text) do begin
    Debut:= PosEx(C_CARACMASK, result, Debut + 1);
    d:= Debut;
    while result[Debut] = C_CARACMASK do inc(Debut);
    k:= NombreSuivantPlace(FCoef, j);
    t:= IntTostr(i div k);
    i:= i mod k;
    t:= Caractere('0', (Debut - d) - Length(t)) + t;
    result:= StringReplace(result, Caractere(C_CARACMASK, Debut - d), t, []);
  end;
  // Applique Signe
  if FVoirSigne and (result <> '') then begin
    if (result[1] = '-') or (result[1] = '+') then result:= copy(result, 2, Length(result));
    if Negatif then result:= '-' + result else result:= '+' + result;
  end;
end;

procedure TEditUpDown.SelectionNombre(P: Integer);
var
  Debut, Fin: Integer;
  sMask: String;
begin
  sMask:= CreerMask(Text) + ' ' + C_CARACMASK;
  Fin:= 0;
  repeat
    Fin:= PosEx(C_CARACMASK, sMask, Fin + 1);
    Debut:= Fin;
    while sMask[Fin] = C_CARACMASK do inc(Fin);
    Dec(P);
  until (P <= 0);
  SelStart:= Debut - 1;
  SelLength:= Fin - Debut;
end;


//------------------------------------------------------------------------------
// Fonction public

// Pour Lire la position
function TEditUpDown.txmLire(): Integer;
begin
  result:= LireMask(Text);
end;

// Pour Ecrire la position
procedure TEditUpDown.txmEcrire(Valeur: Integer);
begin
  if Valeur > LireMask(FMaskMax) then Valeur:= LireMask(FMaskMax);
  if Valeur < LireMask(FMaskMin) then Valeur:= LireMask(FMaskMin);

  Text:= EcrireMask(IntToStr(Valeur));

  // Applique le pluriel
  if FPluriel then begin
    if Text[length(Text)] = 's' then Text:= copy(Text, 1, Length(Text) - 1);
    if LireMask(Text) > 1 then Text:= Text + 's';
  end;  
end;

procedure TEditUpDown.txmudvChange(Key: Word);
var
  i, p, nbMax, nbMin, nbPlace, SaveSelStart, SaveSelLength: Integer;
  sMask: String;
begin
  if Text = '' then exit;
  SaveSelStart:= SelStart; SaveSelLength:= SelLength;

  nbPlace:= PlaceSuivantPosition(Text, SelStart);
  nbMax:= NombreSuivantPlace(FMaskMax, nbPlace);
  nbMin:= NombreSuivantPlace(FMaskMin, nbPlace);
  if FVoirSigne and (FMaskMin[1] = '-') then nbMin:= -nbMin;
  if not(FVoirSigne) or ((SelText <> '-') and (SelText <> '+')) or (SelStart > 2) then begin
    if (Key = VK_ADD) then Key:= VK_Up;
    if (Key = VK_SUBTRACT) then Key:= VK_DOWN;
  end else begin
    if (Key = VK_Up) then Key:= VK_ADD;
    if (Key = VK_DOWN) then Key:= VK_SUBTRACT;
  end;
  if FVoirSigne then begin
    if (Text[1] = '-') then begin
      if (Key = VK_Up) then Key:= VK_DOWN
      else if (Key = VK_DOWN) then Key:= VK_Up;
    end else if (Position = 0) and (Key = VK_DOWN) then begin
      SelStart:= 0;
      SelLength:= 1;
      SelText:= '-';
      SelStart:= SaveSelStart; SelLength:= SaveSelLength;
      Key:= VK_Up;
    end;
  end;

  case Key of
    VK_Up: begin
      p:= NombreSuivantPlace(Text, nbPlace) + 1;
      SelectionNombre(nbPlace);
      SaveSelStart:= SelStart; SaveSelLength:= SelLength;
      if p <= nbMax then SelText:= Caractere('0', SelLength - Length(IntToStr(p))) +  IntToStr(p);
    end;
    VK_DOWN: begin
      p:= NombreSuivantPlace(Text, nbPlace) - 1;
      if p < 0 then p:= 0;
      SelectionNombre(nbPlace);
      SaveSelStart:= SelStart; SaveSelLength:= SelLength;
      if p >= nbMin then SelText:= Caractere('0', SelLength - Length(IntToStr(p))) +  IntToStr(abs(p));
    end;
    VK_ADD: begin
      if SelText <> '' then SelText:= '+';
      Key:= VK_RIGHT;
    end;
    VK_SUBTRACT: begin
      if SelText <> '' then SelText:= '-';
      Key:= VK_RIGHT;
    end;
    96..106: Key:= Key - 48;
    48..58: ;
    VK_RIGHT, VK_LEFT: ;
    VK_DELETE: Key:= 48;
    else exit;
  end;
  // Application du clavier
  if (((47 < Key) and (Key < 59)) or (Key = VK_BACK)) and (SelText <> '') then begin
    SelStart:= SaveSelStart; SelLength:= 1;
    if (Key = VK_BACK) then begin
      if IsNumeric(SelText[1]) then SelText:= '0';
      Key:= VK_LEFT;
    end else begin
      if IsNumeric(SelText[1]) then SelText:= chr(Key);
      Key:= VK_RIGHT;
    end;
    SelStart:= SaveSelStart; SelLength:= 1;
    if NombreSuivantPlace(Text, nbPlace) > nbMax then SelText:= Copy(FMaskMax, SaveSelStart + 1, 1);
    if NombreSuivantPlace(Text, nbPlace) < nbMin then SelText:= Copy(FMaskMin, SaveSelStart + 1, 1);
  end;
  // Pour appliquer les options
  Text:= EcrireMask(Text);
  FMaskMin:= EcrireMask(FMaskMin);
  FMaskMax:= EcrireMask(FMaskMax);

  sMask:= CreerMask(Text) + C_CARACMASK;
  // Avance selection
  if (Key = VK_LEFT) then begin
    i:= SaveSelStart - 1;
    while sMask[i + 1] <> C_CARACMASK do dec(i);
    if i > -1 then SelStart:= i
    else if FVoirSigne then SelStart:= 0;
    SelLength:= 1;
  end else if (Key = VK_RIGHT) then begin
    i:= SaveSelStart + 1;
    while sMask[i + 1] <> C_CARACMASK do inc(i);
    if i < Length(sMask)-1 then SelStart:= i else SelStart:= SaveSelStart;
    SelLength:= 1;
  end else begin
    SelStart:= SaveSelStart;
    SelLength:= SaveSelLength;
  end;
  fudv.Refresh;
end;

procedure TEditUpDown.EcrireMax(Valeur: String);
begin
  //FMaskMax:= EcrireMask(Valeur);
  FMaskMax:= Valeur;
end;

procedure TEditUpDown.EcrireMin(Valeur: String);
begin
  //FMaskMin:= EcrireMask(Valeur);
  FMaskMin:= Valeur;
end;

procedure TEditUpDown.KeyPress(var Key: Char);
begin
  inherited KeyPress(Key);
  if FUpDownEnabled then key:= #0;
end;

procedure TEditUpDown.udvClick(Sender: TObject; Button: TUDBtnType);
begin
  self.SetFocus;
  if Button = btNext then txmudvChange(VK_Up)
  else if Button = btPrev then txmudvChange(VK_DOWN);
end;

procedure TEditUpDown.CacheUpDown(Valeur: Boolean);
begin
  FUpDownEnabled:= Valeur;
  Fudv.Visible:= Valeur;
end;

procedure TEditUpDown.udvDeplace();
begin
  Fudv.Left:= Width - Height;
  Fudv.Top:= 0;
  Fudv.Width:= Height - 4;
  Fudv.Height:= Height - 4;
end;

function TEditUpDown.CreateUpDown: TUpDownSimple;
begin
  Result:= TUpDownSimple.Create(self);
  Result.OnClick := udvClick;
  Result.Visible := True;
  Result.Enabled := True;
  Result.Parent := Self;
  Result.Max:= 32000;
  Result.Min:= -32000;
end;

Constructor TEditUpDown.Create(AOwner: TComponent);
begin
  InHerited Create(AOwner);
  //Self.OnChange:= txmChange;

  Width := 121;
  Height := 25;
  AutoSelect:= False;
  AutoSize:= False;
  FUpDownEnabled:= True;

  Fudv:= CreateUpDown;

  FPluriel:= False;
  FVoirSigne:= False;
  FCoef:= '3600,60,1';

  Text:= '00h 00m 00s';
  FMaskMin:= '00h 00m 00s';
  FMaskMax:= '24h 59m 59s';

  //if (csDesigning in ComponentState) then // si on est en mode conception
end;

destructor TEditUpDown.Destroy;
begin
  Fudv.free;
  inherited Destroy;
end;


procedure Register;
begin
  RegisterComponents('Patdeterre', [TEditUpDown]);
end;

//------------------------------------------------------------------------------
// Tous les vnement bien chiant

procedure TEditUpDown.WMSize(var Message: TWMSize);
begin
  inherited;
  udvDeplace;
end;

procedure TEditUpDown.WMMove(var Message: TWMMove);
begin
  inherited;
  udvDeplace;
end;

procedure TEditUpDown.WMMouseWheel(var Message: TWMMouseWheel);
begin
  inherited;
  if FUpDownEnabled then begin
    if Message.WheelDelta > 0 then txmudvChange(VK_Up)
    else if Message.WheelDelta < 0 then txmudvChange(VK_DOWN);
  end;
end;

procedure TEditUpDown.WMKeyDown(var Message: TWMKeyDown);
begin
  if not(FUpDownEnabled) then
    inherited
  else begin
    txmudvChange(Message.CharCode);
  end;
end;

procedure TEditUpDown.WMPaste(var Message: TMessage);
begin
  if not(FUpDownEnabled) then inherited;
end;

procedure TEditUpDown.WMCut(var Message: TMessage);
begin
  if not(FUpDownEnabled) then inherited;
end;

procedure TEditUpDown.WMClear(var Message: TMessage);
begin
  if not(FUpDownEnabled) then inherited;
end;

procedure TEditUpDown.WMLButtonUp(var Message: TWMLButtonUp);
begin
  inherited;
  if FUpDownEnabled then begin
    if SelLength = 0 then SelStart:= SelStart - 1;
    if SelLength < 2 then SelLength:= 1;
  end;
end;

procedure TEditUpDown.WMSetFocus(var Message: TWMSetFocus);
begin
  Inherited;
  if FUpDownEnabled then begin
    //exit;
    SelStart:= Length(Text);
    txmudvChange(VK_LEFT);
  end;
end;

procedure TEditUpDown.CMEnabledChanged(var Message: TMessage);
begin
  Inherited;
  if FUpDownEnabled then Fudv.Enabled:= self.Enabled;
end;















end.

